
package de.ivu.elect.was.exchange.ergebnis;

import static java.util.Arrays.asList;

import java.util.Collection;

import javax.inject.Inject;

import de.ivu.elect.business.security.Customer;
import de.ivu.elect.business.stimmeingabe.entity.Ergebniseingabestatus;
import de.ivu.elect.business.wahl.entity.NlWahlart;
import de.ivu.elect.business.wahl.entity.Wahl;
import de.ivu.elect.was.exchange.ergebnis.eml.AbstractNlWasEml510xNachGebietErgebniseingabestatusExportMapper;
import de.ivu.elect.was.exchange.ergebnis.eml.Eml510cHSBErgebnisExportMapper;

/**
 * @see NlWasOsv45ControlelijstMainDocumentExportMapper
 */
public class NlWasOsv45ControlelijstEml510cExportMapper extends AbstractNlWasEml510xNachGebietErgebniseingabestatusExportMapper {

  @Inject
  private transient Eml510cHSBErgebnisExportMapper eml510cHSBErgebnisExportMapper;

  public NlWasOsv45ControlelijstEml510cExportMapper() {
    super();
  }

  @Override // https://support.elect-it.com/wiki/x/48g8
  protected Collection<NlWahlart> collectWahlartenAccepted() {
    return asList( //
        NlWahlart.EERSTE_KAMER //
    );
  }

  @Override // https://support.elect-it.com/wiki/x/48g8
  protected boolean isAcceptWahlebene(Wahl wahl, Customer customer) {
    return NlWahlart.isWasHSB(wahl, customer);
  }

  @Override
  protected Collection<Ergebniseingabestatus> collectErgebniseingabestatusAccepted() {
    return asList(Ergebniseingabestatus.FREIGEGEBEN);
  }

  @Override
  protected Eml510cHSBErgebnisExportMapper getEmlExportMapper() {
    return eml510cHSBErgebnisExportMapper;
  }
}
